<?php
header('Content-type: image/svg+xml');
echo '<?xml version="1.0" encoding="UTF-8" standalone="no"?><!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN"
"http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 220 120" width="660" height="360" xmlns:xlink="http://www.w3.org/1999/xlink">';

/* This separate file contains the function svg_schreiben() which does most of the actual drawing (with German text)*/
include('svg_schreiben.inc.php');
/* This contains several functions used both in the German and English version (calling the appropriate svg_schreiben()) */
include('svg_logging_functions.inc.php');

/* Only when a year is given, this will produce a svg */
if (isset($_GET['jahr'])){
  $jahr = $_GET['jahr'];

  if (isset($_GET['mode'])){
    $mode = $_GET['mode'];
    if (($mode < 0) || ($mode > 2))
      $mode = 0;
  }
  else $mode = 0;
  if ($jahr == "alle")  /* The keyword "alle" is a signal to create a chart for all years - with the start year defined here! */
    alldiagramm_erzeugen(2003, $mode, "d");
  else{
    $daten = $jahr . "d.log";
    if (file_exists($daten)){
      $zahlen = $jahr . "d.num";
      /* Create or update the .num file if necessary */
      if (!((file_exists($zahlen) && (filemtime($zahlen) > filemtime($daten)))))
	numerise_logfile($daten, $zahlen);
      diagramm_erzeugen($jahr, $zahlen, $mode);
    }
    else
      echo "<text x='22' y='8' fill='black' font-size='5'>Für das Jahr $jahr liegen keine Daten vor!</text>\n";
  }
}
else
  echo "<text x='22' y='8' fill='black' font-size='5'>Kein Jahr angegeben!</text>\n";
echo "</svg>\n";

?>
