<?php
function numerise_logfile($daten, $zahlen){
  $monat = 0;
  $monat_neu = 0;
  if (file_exists($daten)){
    $logfile = fopen($daten, "r");
    while (!feof($logfile)) {
      $zeile = fgets($logfile);
      $monat_neu = (int)substr($zeile, 5, 2);
      if ($monat_neu > $monat){
	$monat = $monat_neu;  /* Am Ende ist $monat die Nummer des letzten Monats */
	$khtmla[$monat] = 0;
	$operaa[$monat] = 0;
	$geckoa[$monat] = 0;
	$msiea[$monat] = 0;
	$botsa[$monat] = 0;
	$othera[$monat] = 0;
	$linuxa[$monat] = 0;
	$windowsa[$monat] = 0;
	$macintosha[$monat] = 0;
	$bot_osa[$monat] = 0;
	$other_osa[$monat] = 0;
      }
      $bot=FALSE;
      if(strpos($zeile, "KHTML")){ $khtmla[$monat]++; } else
	if(strpos($zeile, "Opera")){ $operaa[$monat]++; } else
	  if(strpos($zeile, "Gecko")) { $geckoa[$monat]++; } else
	    if(strpos($zeile, "MSIE")) { $msiea[$monat]++; } else
	      if (stristr($zeile, "bot") || stristr($zeile, "crawl") || strpos($zeile, "slurp") || strpos($zeile, "spider") || strpos($zeile, "Jeeves") || strpos($zeile, "Yandex")){ $botsa[$monat]++; $bot=TRUE;} else
		$othera[$monat]++;
      if ($bot) $bot_osa[$monat]++; else
	if(strpos($zeile, "Linux")) $linuxa[$monat]++; else
	  if(strpos($zeile, "Windows")) $windowsa[$monat]++; else
	    if(strpos($zeile, "Macintosh")) $macintosha[$monat]++; else
	      $other_osa[$monat]++;
    }
    fclose($logfile);
    /* Bei der letzten Zeile wird einmal fehlerhaft gezählt, Korrektur: */
    $othera[$monat]--;
    $other_osa[$monat]--;

    $numfile = fopen($zahlen, "w");
    /* fopen returns FALSE if it is not successful */
    if ($numfile){
      fwrite($numfile, "<?php\n");
      fwrite($numfile, "\$monate = $monat;\n");
      fwrite($numfile, "\$khtml = unserialize(\"" . serialize($khtmla) . "\");\n");
      fwrite($numfile, "\$opera = unserialize(\"" . serialize($operaa) . "\");\n");
      fwrite($numfile, "\$gecko = unserialize(\"" . serialize($geckoa) . "\");\n");
      fwrite($numfile, "\$msie = unserialize(\"" . serialize($msiea) . "\");\n");
      fwrite($numfile, "\$bots = unserialize(\"" . serialize($botsa) . "\");\n");
      fwrite($numfile, "\$other = unserialize(\"" . serialize($othera) . "\");\n");
      fwrite($numfile, "\$windows = unserialize(\"" . serialize($windowsa) . "\");\n");
      fwrite($numfile, "\$linux = unserialize(\"" . serialize($linuxa) . "\");\n");
      fwrite($numfile, "\$macintosh = unserialize(\"" . serialize($macintosha) . "\");\n");
      fwrite($numfile, "\$other_os = unserialize(\"" . serialize($other_osa) . "\");\n");
      fwrite($numfile, "\$bot_os = unserialize(\"" . serialize($bot_osa) . "\");\n");
      fwrite($numfile, "?>\n");
    }
    else
      echo "<text x='22' y='8' fill='black' font-size='5'>Error writing number file</text>\n";      
  }
}

function summarise_logfile($daten, $zahlen, $summen){
  /* Erzeuge gegebenenfalls fehlende "Nummern"-dateien: */
  if (!(file_exists($zahlen)) || filemtime($zahlen) < filemtime($daten)){
    numerise_logfile($daten, $zahlen);
  }
  include($zahlen);
  /* Jahressummen für Besucherzahlen, Browser und OS ermitteln */
  for ($i = 0; $i <= $monate; $i++){
    /*    $besucher_ges += $besucher[$i]; */
    $khtml_ges += $khtml[$i];
    $opera_ges += $opera[$i];
    $gecko_ges += $gecko[$i];
    $msie_ges += $msie[$i];
    $bots_ges += $bots[$i];
    $other_ges += $other[$i];
    $windows_ges += $windows[$i];
    $linux_ges += $linux[$i];
    $macintosh_ges += $macintosh[$i];
    $bot_os_ges += $bot_os[$i];
    $other_os_ges += $other_os[$i];
  }
  $sumfile = fopen($summen, "w");
  /* fopen returns FALSE if it is not successful */
  if ($sumfile){
    fwrite($sumfile, "<?php\n");
    /*    fwrite($sumfile, "\$besucher = $besucher_ges;\n"); */
    fwrite($sumfile, "\$khtml = $khtml_ges;\n");
    fwrite($sumfile, "\$opera = $opera_ges;\n");
    fwrite($sumfile, "\$gecko = $gecko_ges;\n");
    fwrite($sumfile, "\$msie = $msie_ges;\n");
    fwrite($sumfile, "\$bots = $bots_ges;\n");
    fwrite($sumfile, "\$other = $other_ges;\n");
    fwrite($sumfile, "\$windows = $windows_ges;\n");
    fwrite($sumfile, "\$linux = $linux_ges;\n");
    fwrite($sumfile, "\$macintosh = $macintosh_ges;\n");
    fwrite($sumfile, "\$other_os = $other_os_ges;\n");
    fwrite($sumfile, "\$bot_os = $bot_os_ges;\n");
    fwrite($sumfile, "?>\n");
  }
  else
    echo "<text x='22' y='8' fill='black' font-size='5'>Error writing summary file</text>\n";      
}

function diagramm_erzeugen($jahr, $zahlen, $mode){
  $besucher_ges = 0;
  include($zahlen);
  $total_max = 1; /* Division durch 0 in 'svg_schreiben' vermeiden */
  for ($i = 0; $i <= $monate; $i++){

    if ($mode > 0){ /* Suchmaschinen ausblenden */
      if ($mode > 1){ /* Unbekannte auch ausblenden */
	$other_os[$i] -= $other[$i]; /* Unbekannte Browser ausgeblendet - entsprechend viele Betriebssystem-Einträge entfernen */
	if ($other_os[$i] < 0) /* Trotzdem darf other_os nicht kleiner 0 werden */
	  $other_os[$i] = 0; /* Dies ist eine unsaubere Korrektur, die problematisch würde, gäbe es viel mehr unbekannte BS als Browser */
	$other[$i] = 0;
      }
      $bots[$i] = 0;
      $bot_os[$i] = 0;
    }
    $besucher[$i] = $linux[$i] + $windows[$i] + $macintosh[$i] + $bot_os[$i] + $other_os[$i];
    $besucher_ges += $besucher[$i];
    if ($total_max < $besucher[$i])
      $total_max = $besucher[$i];
  }
  /*    echo "<text x='22' y='8' fill='black' font-size='5'>Schreibe SVG von $zahlen...</text>\n";      */
  svg_schreiben(TRUE, $mode, $jahr, $monate, $total_max, $besucher_ges, $besucher, $khtml, $opera, $gecko, $msie, $bots, $other, $windows, $linux, $macintosh, $other_os, $bot_os);
}

function alldiagramm_erzeugen($startjahr, $mode, $langc){
  $besucher_ges = 0;
  $total_max = 1;

  for ($i = 1; $i <= (date("Y") - $startjahr + 1); $i++){
    $jahr =  ($i + $startjahr - 1);
    $summen = $jahr . $langc . ".sum";
    $daten = $jahr . $langc . ".log";

    /* Erzeuge gegebenenfalls fehlende Summendateien: */
    if (!(file_exists($summen)) || filemtime($summen) < filemtime($daten)){
      $zahlen = $jahr . $langc . ".num";
      summarise_logfile($daten, $zahlen, $summen);
    }
    
    include($summen);

    $botsa[$i] = 0; $bot_os[$i] = 0; $othera[$i] = 0; $other_osa[$i] = 0; /* initialise variables that may not be filled later (depending on 'mode') */
    $khtmla[$i] = $khtml;
    $operaa[$i] = $opera;
    $geckoa[$i] = $gecko;
    $msiea[$i] = $msie;
    $linuxa[$i] = $linux;
    $windowsa[$i] = $windows;
    $macintosha[$i] = $macintosh;
    if ($mode < 2){ /* mode 1 or mode 0, show at least 'others' */
      if ($mode == 0){ /* mode 0: show also the bots */
	$botsa[$i] = $bots;
	$bot_osa[$i] = $bot_os;
      }
      $othera[$i] = $other;
      $other_osa[$i] = $other_os;
    }
    $totala[$i] = $linuxa[$i] + $windowsa[$i] + $macintosha[$i] + $bot_osa[$i] + $other_osa[$i];
    $besucher_ges += $totala[$i];

    if ($total_max < $totala[$i])
      $total_max = $totala[$i];
  }
  svg_schreiben(FALSE, $mode, $startjahr, ($i - 1), $total_max, $besucher_ges, $totala, $khtmla, $operaa, $geckoa, $msiea, $botsa, $othera, $windowsa, $linuxa, $macintosha, $other_osa, $bot_osa);
}
?>
