<?php
  /* Diese Datei wird von svg_erzeugen.php eingebunden */

function svg_schreiben($jahresdiagramm, $mode, $jahr, $balken, $maxwert,  $besucher_ges, $besucher, $khtml, $opera, $gecko, $msie, $bots, $other, $windows, $linux, $macintosh, $other_os, $bot_os){
  if (!$jahresdiagramm)
    $startjahr=$jahr;

  /* Bestimmen der Höhe des Diagramms / Erzeugen einer durch 4 teilbaren Zahl*/
  /* Testwert für diese Funktion:  $total_max = 12117; */
  $i = 0;
  if ($maxwert > 99){
    while ($maxwert > 1){
      $maxwert = $maxwert / 10;
      $i++;
    }
    /* Alles bis auf maximal zwei Stellen wird aufgerundet (12117 -> 13000) */
    $runden_auf = pow(10, ($i - 2));
    $maxwert = ceil($maxwert * 100) * $runden_auf;
  }
  else{
    $runden_auf = 10;
    $maxwert = ceil($maxwert / 10) * $runden_auf;
  }
  if (fmod($maxwert, 4) > 0)
    $maxwert += $runden_auf;

  $x_axis = 110;
  $y_axis = 20;
  $y2_axis = 162;

  /*  print "Stellen von total_max (i) = $i, total_max = $total_max, maxwert = $maxwert, x_axis = $x_axis, runden_auf: $runden_auf <br>"; */

  $browser_width = ($y2_axis - 2) / ($balken + $balken / 3) / 2;
  $os_width = $browser_width;
  $os_opacity = 0.9;

  /* Hintergrund füllen */
  echo "\n<rect x='0' class='svgBackground' y='0' height='120' style='fill:#ffffff;' width='220'/>\n";

  /* Diagramm-Titel: */
  echo "<text x='22' y='8' fill='black' font-size='5'>$besucher_ges Besucher " . ($jahresdiagramm ? "im Jahr $jahr" : "von $startjahr bis heute") . "</text>\n";

  /* Legende */
  $lleft = $y2_axis + 6;
  $ynavi = 22;
  echo "<text x='" . $lleft . "' y='14' fill='black' font-size='5'>Netznavigator:</text>\n";
  if ($mode < 2){ /* mode 1 or mode 0, show at least 'others' */
    if ($mode == 0){ /* mode 0: show also the bots */
      echo "<a xlink:href='http://de.wikipedia.org/wiki/Webcrawler' target='_top' xlink:title='Google, Yahoo! und Verwandte'><text x='" . $lleft . "' y='$ynavi' fill='#909' font-size='5'>Suchmaschinen</text></a>\n";
      $ynavi += 6;
    }
    echo "<a xlink:href='http://de.wikipedia.org/wiki/Webbrowser' target='_top' xlink:title='Andere/ maskierte Browser'><text x='" . $lleft . "' y='$ynavi' fill='#0f0' font-size='5'>Andere</text></a>\n";
    $ynavi += 6;
  }
  echo "<a xlink:href='http://de.wikipedia.org/wiki/Opera' target='_top' xlink:title='Opera'><text x='" . $lleft . "' y='$ynavi' fill='#f90' font-size='5'>Opera</text></a>\n";
  echo "<a xlink:href='http://de.wikipedia.org/wiki/KHTML' target='_top' xlink:title='Konqueror, Safari, Chrome und Verwandte'><text x='" . $lleft . "' y='" . ($ynavi + 6) . "' fill='#8b97ac' font-size='5'>KHTML</text></a>\n";
  echo "<a xlink:href='http://de.wikipedia.org/wiki/Windows_Internet_Explorer' target='_top' xlink:title='Microsoft (Windows) Internet Explorer'><text x='" . $lleft . "' y='" . ($ynavi + 12) . "' fill='#00f' font-size='5'>MSIE</text></a>\n";
  echo "<a xlink:href='http://de.wikipedia.org/wiki/Gecko_(Software)' target='_top' xlink:title='Mozilla Firefox und Verwandte'><text x='" . $lleft . "' y='" . ($ynavi + 18) . "' fill='#f00' font-size='5'>Gecko</text></a>\n";

  echo "<text x='" . $lleft . "' y='" . ($ynavi + 36) . "' fill='black' font-size='5'>Betriebssystem:</text>\n";
  if ($mode == 0)
    echo "<a xlink:href='http://de.wikipedia.org/wiki/Webcrawler' target='_top' xlink:title='Google, Yahoo! und Verwandte'><text x='" . $lleft . "' y='" . ($ynavi + 44) . "' fill='#909' font-size='5'>Suchmaschinen</text></a>\n";
  else
    $ynavi -= 6;
  echo "<a xlink:href='http://de.wikipedia.org/wiki/Liste_der_Betriebssysteme' xlink:title='Andere/ maskierte Betriebssysteme' target='_top'><text x='" . $lleft . "' y='" . ($ynavi + 50) . "' fill='#0f0' font-size='5'>Andere</text></a>\n";
  echo "<a xlink:href='http://www.apple.com/de/macosx/' target='_top' xlink:title='Apples Mac OS X'><text x='" . $lleft . "' y='" . ($ynavi + 56) . "' fill='#8b97ac' font-size='5'>Mac OS</text></a>\n";
  echo "<a xlink:href='http://www.microsoft.com/windows/' xlink:title='Microsoft Windows' target='_top'><text x='" . $lleft . "' y='" . ($ynavi + 62) . "' fill='#00f' font-size='5'>Windows</text></a>\n";
  echo "<a xlink:href='http://www.debian.org/' xlink:title='DIE freie GNU/Linux-Distribution' target='_top'><text x='" . $lleft . "' y='" . ($ynavi + 68) . "' fill='#f00' font-size='5'>GNU/Linux</text></a>\n";

  echo "<line x1='$y_axis' x2='$y2_axis' y1='10' y2='10' id='b100proz' style='stroke: #000000; stroke-width: 0.5px;'/>\n";
  echo "<text x='2' y='10' fill='black' font-size='5'>$maxwert</text>\n";    

  echo "<line x1='$y_axis' x2='$y2_axis' y1='35' y2='35' id='b75proz' style='stroke: #000000; stroke-width: 0.5px;'/>\n\n";
  echo "<text x='2' y='35' fill='black' font-size='5'>" . ($maxwert * 0.75) . "</text>\n";

  echo "<line x1='$y_axis' x2='$y2_axis' y1='60' y2='60' id='b50proz' style='stroke: #000000; stroke-width: 0.5px;'/>\n";
  echo "<text x='2' y='60' fill='black' font-size='5'>" . ($maxwert / 2) . "</text>\n";

  echo "<line x1='$y_axis' x2='$y2_axis' y1='85' y2='85' id='b25proz' style='stroke: #000000; stroke-width: 0.5px;'/>\n";
  echo "<text x='2' y='85' fill='black' font-size='5'>" . ($maxwert * 0.25) . "</text>\n";

  echo "<line x1='$y_axis' x2='$y2_axis' y1='$x_axis' y2='$x_axis' id='xAxis' style='stroke: #000000; stroke-width: 1px;'/>\n";
  echo "<line x1='$y_axis' x2='20' y1='10' y2='$x_axis' id='yAxis' style='stroke: #000000; stroke-width: 1px;'/>\n";

    if (!(($jahresdiagramm) && ($balken < 12))) /* Kein rechter Abschluss des Diagramms bei unvollständigen Jahresdiagrammen */
      echo "<line x1='$y2_axis' x2='$y2_axis' y1='10' y2='$x_axis' style='stroke: #000000; stroke-width: 1px;'/>\n";

    for ($i = 1; $i <= $balken; $i++){
      $xpos = $y_axis + 2 + (140 / $balken) * ($i - 1); /* Wo der Balken liegt */
      if ($besucher[$i] > 0){               /* Wenn keine Besucher kamen, gibt es nichts zu zeichnen (außer den Monatsnamen) */
	$xpos_os = $xpos + $browser_width / 3 * 2;        /* Balken für Betriebssysteme */

	$linux_r = 100 * $linux[$i] / $maxwert;
	$linux_p = round($linux[$i] / $besucher[$i] * 100);
	echo "<rect x='" . $xpos_os . "' y='" . ($x_axis - $linux_r) . "' height='" . $linux_r ."' width='" . $os_width . "' style='fill:red;fill-opacity:$os_opacity;'><title>Linux: $linux[$i] (" . $linux_p . "%)</title></rect>\n";

	$win_r = 100 * $windows[$i] / $maxwert;
	$win_p = round($windows[$i] / $besucher[$i] * 100);
	echo "<rect x='" . $xpos_os . "' y='" . ($x_axis - $linux_r - $win_r) . "' height='" . $win_r ."' width='" . $os_width . "' style='fill:#0000ff;fill-opacity:$os_opacity;'><title>Windows: $windows[$i] (" . $win_p . "%)</title></rect>\n";

	$mac_r = 100 * $macintosh[$i] / $maxwert;
	$mac_p = round(100 * $macintosh[$i] / $besucher[$i]);
	echo "<rect x='" . $xpos_os . "' y='" . ($x_axis - $linux_r - $win_r - $mac_r) . "' height='" . $mac_r ."' width='" . $os_width . "' style='fill:#8b97ac;fill-opacity:$os_opacity;'><title>Mac OS: $macintosh[$i] (" . $mac_p . "%)</title></rect>\n";

	$other_os_r = 100 * $other_os[$i] / $maxwert;
	$other_os_p = round(100 * $other_os[$i] / $besucher[$i]);
	echo "<rect x='" . $xpos_os . "' y='" . ($x_axis - $linux_r - $win_r - $mac_r - $other_os_r) . "' height='" . $other_os_r ."' width='" . $os_width . "' style='fill:#00ff00;fill-opacity:$os_opacity;'><title>Andere: $other_os[$i] (" . $other_os_p . "%)</title></rect>\n";

	$bot_os_r = 100 * $bot_os[$i] / $maxwert;
	$bot_os_p = round(100 * $bot_os[$i] / $besucher[$i]);
	/* Damit Browser- und OS-Balken exakt gleich hoch sind (und nur einmal gerechnet werden muss): */
	$balkenhoehe = $x_axis - $linux_r - $win_r - $mac_r - $other_os_r - $bot_os_r;
	echo "<rect x='" . $xpos_os . "' y='" . $balkenhoehe . "' height='" . $bot_os_r ."' width='" . $os_width . "' style='fill:#990099;fill-opacity:$os_opacity;'><title>Suchmaschinen: $bot_os[$i] (" . $bot_os_p . "%)</title></rect>\n";

	$gecko_r = 100 * $gecko[$i] / $maxwert;
	$gecko_p = round(100 * $gecko[$i] / $besucher[$i]);
	echo "<rect x='" . $xpos . "' y='" . ($x_axis - $gecko_r) . "' height='" . $gecko_r ."' width='" . $browser_width . "' style='fill:red;fill-opacity:0.7;'><title>Gecko: $gecko[$i] (" . $gecko_p . "%)</title></rect>\n";

	$msie_r = 100 * $msie[$i] / $maxwert;
	$msie_p = round($msie[$i] / $besucher[$i] * 100);
	echo "<rect x='" . $xpos . "' y='" . ($x_axis - $msie_r - $gecko_r) . "' height='" . $msie_r ."' width='" . $browser_width . "' style='fill:#00f;fill-opacity:0.7;'><title>MSIE: $msie[$i] (" . $msie_p . "%)</title></rect>\n";

	$khtml_r = 100 * $khtml[$i] / $maxwert;
	$khtml_p = round(100 * $khtml[$i] / $besucher[$i]);
	echo "<rect x='" . $xpos. "' y='" . ($x_axis - $msie_r - $gecko_r - $khtml_r) . "' height='" . $khtml_r ."' width='" . $os_width . "' style='fill:#8b97ac;fill-opacity:0.7;'><title>KHTML: $khtml[$i] (" . $khtml_p . "%)</title></rect>\n";

	$opera_r = 100 * $opera[$i] / $maxwert;
	$opera_p = round(100 * $opera[$i] / $besucher[$i]);
	echo "<rect x='" . $xpos . "' y='" . ($x_axis - $msie_r - $gecko_r - $khtml_r - $opera_r) . "' height='" . $opera_r ."' width='" . $browser_width . "' style='fill:#f90;fill-opacity:0.7;'><title>Opera: $opera[$i] (" . $opera_p . "%)</title></rect>\n";

	$other_r = 100 * $other[$i] / $maxwert;
	$other_p = round(100 * $other[$i] / $besucher[$i]);
	echo "<rect x='" . $xpos . "' y='" . ($x_axis - $msie_r - $gecko_r - $opera_r - $khtml_r - $other_r) . "' height='" . $other_r ."' width='" . $browser_width . "' style='fill:#0f0;fill-opacity:0.7;'><title>Andere: $other[$i] (" . $other_p . "%)</title></rect>\n";

	$bots_r = 100 * $bots[$i] / $maxwert;
	$bots_p = round(100 * $bots[$i] / $besucher[$i]);
	echo "<rect x='" . $xpos . "' y='" . $balkenhoehe . "' height='" . $bots_r ."' width='" . $browser_width . "' style='fill:#909;fill-opacity:0.7;'><title>Suchmaschinen: $bots[$i] (" . $bots_p . "%)</title></rect>\n";

    }
    /* Den Monatsnamen oder die Jahreszahl schreiben (day 15 is important so there is no problem with February on days > 28) */
    $b_index = ($jahresdiagramm? date("M", mktime(12, 30, 30, $i, 15, 1980)) : ($startjahr - 1 + $i));
    echo "<text x='" . $xpos . "' y='115' fill='black' font-size='5'>" . $b_index . "</text>\n";

  }
}
?>
